/* 
 * Copyright (c) 2005-2006 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _CANVAS_H
#define _CANVAS_H


class Canvas {

public:
    class Scene *scene;
    bool		  refresh;
    int			  active;
    unsigned long last_tick;
    bool		  fullscreen;
    bool		  panoramic;
    int			  width, height;
    int			  fps;

 public:
    Canvas (Scene *scene_, bool fullscreen_, int fps_);
    virtual ~Canvas (void);
    
    virtual int   init   (void) = 0;
    virtual int   process_events (void) = 0;


    virtual void  resize (void);
    virtual void  render (float dt);
    virtual int   loop   (void);
    virtual float wait_next_tick (void);
};

#endif
