/* 
 * Copyright (c) 2005-2006 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _HEIGHT_FIELD_H
#define _HEIGHT_FIELD_H

#include <vector>
#include <string>
#include <SDL.h>
#include <GL/gl.h>
#include "texture.h"
#include "struct.h"



class HeightField {
 public:
	HeightField (std::string height_map,
                 std::string light_map,
                 std::string detail_map);
	~HeightField (void);
	void make (int size_=64);
	void render (void);


 private:
	SDL_Surface *		surface;		// This is the map image
	unsigned char *		data;			// pointer to pixel data
	Texture	*			lighttex;		// Light texture
	Texture *			detailtex;		// Detail texture
	int					size;			// Size of the mesh in nuimber of vertex per row

	Vertex *			vertices;
	GLint				n_vertices;
	GLuint *			indices;
	GLint				n_indices;
};

#endif // _HEIGHT_FIELD_H
