/* 
 * Copyright (c) 2005-2006 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef	_STRUCT_H
#define	_STRUCT_H

struct Vec4f {
    union {
        float x;			// x component
        float dx;			//  or dx
        float r;			//  or r
        float red;			//  or red
    };
    union {
        float y;			// y component
        float dy;			//  or dy
        float g;			//  or g
			float green;		//  or green
    };
    union {
        float z;			// z component
        float dz;			//  or dz
        float b;			//  or b
        float blue;			//  or blue
        float width;		//  or width
    };
    union {
        float w;			// a component
        float dw;			//  or dw
        float a;			//  or a
        float alpha;		//  or alpha
        float height;		//  or height
    };

    // Default initialization
    Vec4f (void) {
        x = 0;
        y = 0;
        z = 0;
        w = 0;
    }
    Vec4f (const float a, const float b, const float c, const float d) {
        x = a;
        y = b;
        z = c;
        w = d;
    }
};

typedef Vec4f Surface;


struct Vertex {
    union {
        float x;			// x component
        float dx;			//  or dx
        float r;			//  or r
        float red;			//  or red
    };
    union {
        float y;			// y component
        float dy;			//  or dy
        float g;			//  or g
        float green;		//  or green
    };
    union {
        float z;			// z component
        float dz;			//  or dz
        float b;			//  or b
        float blue;			//  or blue
    };
    float u0;
    float v0;
    float u1;
    float v1;
};


#endif // _STRUCT_H
