/* 
 * Copyright (c) 2005-2006 Nicolas Rougier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef	_TEXTURE_H
#define	_TEXTURE_H

#include <vector>
#include <string>
#include <SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>

class Texture {
 public:
    std::string		filename;
    bool			alpha;
    bool			repeat;
    GLuint			id;

 public:
    Texture (std::string filename, bool alpha_ = false, bool repeat_ = false);
    ~Texture (void);
    void generate (void);

 private:
	GLubyte *load (int &width, int &height);
	Uint32 pixel (SDL_Surface *surface, int x, int y);
};

#endif
